SET QUOTED_IDENTIFIER ON 
GO

SET ANSI_NULLS ON 
GO

IF EXISTS (SELECT name FROM sysobjects WHERE name = 'BDSMP2_DELETES')
	DROP TABLE BDSMP2_DELETES
GO

CREATE TABLE BDSMP2_DELETES
(
	SQLTEXT     TEXT NOT NULL ,
	UPDATESTAMP DATETIME NOT NULL ,
	UPDATEUSER  VARCHAR(30) NULL
)
GO

IF EXISTS (SELECT name FROM sysobjects WHERE name = 'BDSMP2_STATUS')
	DROP TABLE BDSMP2_STATUS
GO

CREATE TABLE BDSMP2_STATUS (
	CODE varchar (25) NOT NULL ,
	VAL varchar (25) NULL ,
	UPDATESTAMP datetime NULL ,
	UPDATEUSER varchar(30) NULL
)
GO

ALTER TABLE BDSMP2_STATUS WITH NOCHECK ADD 
	CONSTRAINT PK_BDSMP2_STATUS PRIMARY KEY  CLUSTERED 
	(
		CODE
	)
GO

IF EXISTS (SELECT name FROM sysobjects WHERE name = 'BDSMP2_PRIORITY')
	DROP TABLE BDSMP2_PRIORITY
GO

CREATE TABLE BDSMP2_PRIORITY (
	CODE varchar (25) NOT NULL ,
	DESCRIPTION varchar (25) NULL ,
	UPDATESTAMP datetime NULL ,
	UPDATEUSER varchar(30) NULL
)
GO

ALTER TABLE BDSMP2_PRIORITY WITH NOCHECK ADD 
	CONSTRAINT PK_BDSMP2_PRIORITY PRIMARY KEY  CLUSTERED 
	(
		CODE
	)
GO

DELETE FROM BDSMP2_PRIORITY;
INSERT INTO BDSMP2_PRIORITY (CODE, DESCRIPTION) VALUES ('1', 'Highest');
INSERT INTO BDSMP2_PRIORITY (CODE, DESCRIPTION) VALUES ('2', 'High');
INSERT INTO BDSMP2_PRIORITY (CODE, DESCRIPTION) VALUES ('3', 'Medium');
INSERT INTO BDSMP2_PRIORITY (CODE, DESCRIPTION) VALUES ('4', 'Low');
INSERT INTO BDSMP2_PRIORITY (CODE, DESCRIPTION) VALUES ('5', 'Lowest');
GO

DELETE FROM BDSMP2_STATUS;
INSERT INTO BDSMP2_STATUS (CODE, VAL) VALUES ('O', 'Open');
INSERT INTO BDSMP2_STATUS (CODE, VAL) VALUES ('R', 'Ready');
INSERT INTO BDSMP2_STATUS (CODE, VAL) VALUES ('H', 'Hold');
INSERT INTO BDSMP2_STATUS (CODE, VAL) VALUES ('M', 'Completed');
INSERT INTO BDSMP2_STATUS (CODE, VAL) VALUES ('T', 'Transfer');
GO