SET QUOTED_IDENTIFIER ON 
GO

SET ANSI_NULLS ON 
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_RFO_UPDATESTAMP]'))
DROP TRIGGER BDS_RFO_UPDATESTAMP
GO

CREATE TRIGGER BDS_RFO_UPDATESTAMP
ON RFO AFTER INSERT, UPDATE
AS 
BEGIN
	UPDATE RFO
		SET RFO.UPDATESTAMP = GETDATE()
	FROM RFO
		INNER JOIN inserted ON 
			RFO.EQTYPE = inserted.EQTYPE AND RFO.RFOCODE = inserted.RFOCODE
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_SOLUTIONS_UPDATESTAMP]'))
DROP TRIGGER BDS_SOLUTIONS_UPDATESTAMP
GO

CREATE TRIGGER BDS_SOLUTIONS_UPDATESTAMP
ON SOLUTIONS AFTER INSERT, UPDATE
AS 
BEGIN
	UPDATE SOLUTIONS
		SET SOLUTIONS.UPDATESTAMP = GETDATE()
	FROM SOLUTIONS
		INNER JOIN inserted ON 
			SOLUTIONS.SOLUTIONCODE = inserted.SOLUTIONCODE
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_WOC_UPDATESTAMP]'))
DROP TRIGGER BDS_WOC_UPDATESTAMP
GO

CREATE TRIGGER BDS_WOC_UPDATESTAMP
ON WOC AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE WOC
		SET WOC.UPDATESTAMP = GETDATE()
	FROM WOC
		INNER JOIN inserted ON 
			WOC.WONUM = inserted.WONUM AND WOC.CLOSEDATE = inserted.CLOSEDATE AND WOC.SITEID = inserted.SITEID AND
			WOC.EQNUM = inserted.EQNUM AND WOC.LOCATION = inserted.LOCATION AND WOC.SUBLOCATION1 = inserted.SUBLOCATION1 AND
			WOC.SUBLOCATION2 = inserted.SUBLOCATION2 AND WOC.SUBLOCATION3 = inserted.SUBLOCATION3
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_VENDORSITEINFO_UPDATESTAMP]'))
DROP TRIGGER BDS_VENDORSITEINFO_UPDATESTAMP
GO

CREATE TRIGGER BDS_VENDORSITEINFO_UPDATESTAMP
ON VENDORSITEINFO AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE VENDORSITEINFO
		SET VENDORSITEINFO.UPDATESTAMP = GETDATE()
	FROM VENDORSITEINFO
		INNER JOIN inserted ON 
			VENDORSITEINFO.VENDORID = inserted.VENDORID AND VENDORSITEINFO.VENDORBRANCHID = inserted.VENDORBRANCHID AND
			VENDORSITEINFO.SITEID = inserted.SITEID
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_CRAFTS_UPDATESTAMP]'))
DROP TRIGGER BDS_CRAFTS_UPDATESTAMP
GO

CREATE TRIGGER BDS_CRAFTS_UPDATESTAMP
ON CRAFTS AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE CRAFTS
		SET CRAFTS.UPDATESTAMP = GETDATE()
	FROM CRAFTS
		INNER JOIN inserted ON 
			CRAFTS.CRAFT = inserted.CRAFT
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_EQTYPE_UPDATESTAMP]'))
DROP TRIGGER BDS_EQTYPE_UPDATESTAMP
GO

CREATE TRIGGER BDS_EQTYPE_UPDATESTAMP
ON EQTYPE AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE EQTYPE
		SET EQTYPE.UPDATESTAMP = GETDATE()
	FROM EQTYPE
		INNER JOIN inserted ON 
			EQTYPE.EQTYPE = inserted.EQTYPE
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_INVTYPE_UPDATESTAMP]'))
DROP TRIGGER BDS_INVTYPE_UPDATESTAMP
GO

CREATE TRIGGER BDS_INVTYPE_UPDATESTAMP
ON INVTYPE AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE INVTYPE
		SET INVTYPE.UPDATESTAMP = GETDATE()
	FROM INVTYPE
		INNER JOIN inserted ON 
			INVTYPE.TYPE = inserted.TYPE
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_STOCK_UPDATESTAMP]'))
DROP TRIGGER BDS_STOCK_UPDATESTAMP
GO

CREATE TRIGGER BDS_STOCK_UPDATESTAMP
ON STOCK AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE STOCK
		SET STOCK.UPDATESTAMP = GETDATE()
	FROM STOCK
		INNER JOIN inserted ON 
			STOCK.ITEMNUM = inserted.ITEMNUM AND STOCK.WAREHOUSEID = inserted.WAREHOUSEID AND STOCK.LOCATION = inserted.LOCATION
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_INVY_UPDATESTAMP]'))
DROP TRIGGER BDS_INVY_UPDATESTAMP
GO

CREATE TRIGGER BDS_INVY_UPDATESTAMP
ON INVY AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE INVY
		SET INVY.UPDATESTAMP = GETDATE()
	FROM INVY
		INNER JOIN inserted ON 
			INVY.ITEMNUM = inserted.ITEMNUM
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_LOCATION_UPDATESTAMP]'))
DROP TRIGGER BDS_LOCATION_UPDATESTAMP
GO

CREATE TRIGGER BDS_LOCATION_UPDATESTAMP
ON LOCATION AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE LOCATION
		SET LOCATION.UPDATESTAMP = GETDATE()
	FROM LOCATION
		INNER JOIN inserted ON 
			LOCATION.LOCATION = inserted.LOCATION AND LOCATION.SUBLOCATION1 = inserted.SUBLOCATION1 AND
			LOCATION.SUBLOCATION2 = inserted.SUBLOCATION2 AND LOCATION.SUBLOCATION3 = inserted.SUBLOCATION3
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_RFFCODES_UPDATESTAMP]'))
DROP TRIGGER BDS_RFFCODES_UPDATESTAMP
GO

CREATE TRIGGER BDS_RFFCODES_UPDATESTAMP
ON RFFCODES AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE RFFCODES
		SET RFFCODES.UPDATESTAMP = GETDATE()
	FROM RFFCODES
		INNER JOIN inserted ON 
			RFFCODES.RFFCODE = inserted.RFFCODE
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_RFOCODES_UPDATESTAMP]'))
DROP TRIGGER BDS_RFOCODES_UPDATESTAMP
GO

CREATE TRIGGER BDS_RFOCODES_UPDATESTAMP
ON RFOCODES AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE RFOCODES
		SET RFOCODES.UPDATESTAMP = GETDATE()
	FROM RFOCODES
		INNER JOIN inserted ON 
			RFOCODES.RFOCODE = inserted.RFOCODE
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_SITE_UPDATESTAMP]'))
DROP TRIGGER BDS_SITE_UPDATESTAMP
GO

CREATE TRIGGER BDS_SITE_UPDATESTAMP
ON SITE AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE SITE
		SET SITE.UPDATESTAMP = GETDATE()
	FROM SITE
		INNER JOIN inserted ON 
			SITE.SITEID = inserted.SITEID
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_WAREHOUSE_UPDATESTAMP]'))
DROP TRIGGER BDS_WAREHOUSE_UPDATESTAMP
GO

CREATE TRIGGER BDS_WAREHOUSE_UPDATESTAMP
ON WAREHOUSE AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE WAREHOUSE
		SET WAREHOUSE.UPDATESTAMP = GETDATE()
	FROM WAREHOUSE
		INNER JOIN inserted ON 
			WAREHOUSE.WAREHOUSEID = inserted.WAREHOUSEID
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_WOTYPE_UPDATESTAMP]'))
DROP TRIGGER BDS_WOTYPE_UPDATESTAMP
GO

CREATE TRIGGER BDS_WOTYPE_UPDATESTAMP
ON WOTYPE AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE WOTYPE
		SET WOTYPE.UPDATESTAMP = GETDATE()
	FROM WOTYPE
		INNER JOIN inserted ON 
			WOTYPE.WOTYPE = inserted.WOTYPE
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_METER_UPDATESTAMP]'))
DROP TRIGGER BDS_METER_UPDATESTAMP
GO

CREATE TRIGGER BDS_METER_UPDATESTAMP
ON METER AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE METER
		SET METER.UPDATESTAMP = GETDATE()
	FROM METER
		INNER JOIN inserted ON 
			METER.EQNUM = inserted.EQNUM AND METER.METERNUM = inserted.METERNUM
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_MTRHIST_UPDATESTAMP]'))
DROP TRIGGER BDS_MTRHIST_UPDATESTAMP
GO

CREATE TRIGGER BDS_MTRHIST_UPDATESTAMP
ON MTRHIST AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE MTRHIST
		SET MTRHIST.UPDATESTAMP = GETDATE()
	FROM MTRHIST
		INNER JOIN inserted ON 
			MTRHIST.EQNUM = inserted.EQNUM AND MTRHIST.METERNUM = inserted.METERNUM AND
			MTRHIST.EQDATE = inserted.EQDATE AND MTRHIST.EQTIME = inserted.EQTIME
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_WOP_UPDATESTAMP]'))
DROP TRIGGER BDS_WOP_UPDATESTAMP
GO

CREATE TRIGGER BDS_WOP_UPDATESTAMP
ON WOP AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE WOP
		SET WOP.UPDATESTAMP = GETDATE()
	FROM WOP
		INNER JOIN inserted ON 
			WOP.WONUM = inserted.WONUM AND WOP.CLOSEDATE = inserted.CLOSEDATE AND WOP.SITEID = inserted.SITEID AND
			WOP.EQNUM = inserted.EQNUM AND WOP.LOCATION = inserted.LOCATION AND WOP.SUBLOCATION1 = inserted.SUBLOCATION1 AND
			WOP.SUBLOCATION2 = inserted.SUBLOCATION2 AND WOP.SUBLOCATION3 = inserted.SUBLOCATION3 AND
			WOP.ITEMNUM = inserted.ITEMNUM AND WOP.DATEUSED = inserted.DATEUSED
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_EQUIP_UPDATESTAMP]'))
DROP TRIGGER BDS_EQUIP_UPDATESTAMP
GO

CREATE TRIGGER BDS_EQUIP_UPDATESTAMP
ON EQUIP AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE EQUIP
		SET EQUIP.UPDATESTAMP = GETDATE()
	FROM EQUIP
		INNER JOIN inserted ON 
			EQUIP.EQNUM = inserted.EQNUM
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_EMP_UPDATESTAMP]'))
DROP TRIGGER BDS_EMP_UPDATESTAMP
GO

CREATE TRIGGER BDS_EMP_UPDATESTAMP
ON EMP AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE EMP
		SET EMP.UPDATESTAMP = GETDATE()
	FROM EMP
		INNER JOIN inserted ON 
			EMP.EMPCODE = inserted.EMPCODE
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_PROJECT_UPDATESTAMP]'))
DROP TRIGGER BDS_PROJECT_UPDATESTAMP
GO

CREATE TRIGGER BDS_PROJECT_UPDATESTAMP
ON PROJECT AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE PROJECT
		SET PROJECT.UPDATESTAMP = GETDATE()
	FROM PROJECT
		INNER JOIN inserted ON 
			PROJECT.PROJECTID = inserted.PROJECTID AND PROJECT.PROJECTTASK = inserted.PROJECTTASK AND PROJECT.SITEID = inserted.SITEID
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_INSTR_UPDATESTAMP]'))
DROP TRIGGER BDS_INSTR_UPDATESTAMP
GO

CREATE TRIGGER BDS_INSTR_UPDATESTAMP
ON INSTR AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE INSTR
		SET INSTR.UPDATESTAMP = GETDATE()
	FROM INSTR
		INNER JOIN inserted ON 
			INSTR.INSTRCODE = inserted.INSTRCODE
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_TSKINSTR_UPDATESTAMP]'))
DROP TRIGGER BDS_TSKINSTR_UPDATESTAMP
GO

CREATE TRIGGER BDS_TSKINSTR_UPDATESTAMP
ON TSKINSTR AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE TSKINSTR
		SET TSKINSTR.UPDATESTAMP = GETDATE()
	FROM TSKINSTR
		INNER JOIN inserted ON 
			TSKINSTR.TASKNUM = inserted.TASKNUM AND TSKINSTR.INSTRCODE = inserted.INSTRCODE AND TSKINSTR.SITEID = inserted.SITEID
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_TENANT_UPDATESTAMP]'))
DROP TRIGGER BDS_TENANT_UPDATESTAMP
GO

CREATE TRIGGER BDS_TENANT_UPDATESTAMP
ON TENANT AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE TENANT
		SET TENANT.UPDATESTAMP = GETDATE()
	FROM TENANT
		INNER JOIN inserted ON 
			TENANT.TENANT = inserted.TENANT AND TENANT.SITEID = inserted.SITEID AND
			TENANT.LOCATION = inserted.LOCATION AND TENANT.SUBLOCATION1 = inserted.SUBLOCATION1 AND
			TENANT.SUBLOCATION2 = inserted.SUBLOCATION2 AND TENANT.SUBLOCATION3 = inserted.SUBLOCATION3
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_WOV_UPDATESTAMP]'))
DROP TRIGGER BDS_WOV_UPDATESTAMP
GO

CREATE TRIGGER BDS_WOV_UPDATESTAMP
ON WOV AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE WOV
		SET WOV.UPDATESTAMP = GETDATE()
	FROM WOV
		INNER JOIN inserted ON 
			WOV.WONUM = inserted.WONUM AND WOV.CLOSEDATE = inserted.CLOSEDATE AND WOV.SITEID = inserted.SITEID AND
			WOV.EQNUM = inserted.EQNUM AND WOV.LOCATION = inserted.LOCATION AND WOV.SUBLOCATION1 = inserted.SUBLOCATION1 AND
			WOV.SUBLOCATION2 = inserted.SUBLOCATION2 AND WOV.SUBLOCATION3 = inserted.SUBLOCATION3 AND
			WOV.VENDORID = inserted.VENDORID AND WOV.PERFORMEDBY = inserted.PERFORMEDBY
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_VENDOR_UPDATESTAMP]'))
DROP TRIGGER BDS_VENDOR_UPDATESTAMP
GO

CREATE TRIGGER BDS_VENDOR_UPDATESTAMP
ON VENDOR AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE VENDOR
		SET VENDOR.UPDATESTAMP = GETDATE()
	FROM VENDOR
		INNER JOIN inserted ON 
			VENDOR.VENDORID = inserted.VENDORID AND VENDOR.VENDORBRANCHID = inserted.VENDORBRANCHID
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_INVCOST_UPDATESTAMP]'))
DROP TRIGGER BDS_INVCOST_UPDATESTAMP
GO

CREATE TRIGGER BDS_INVCOST_UPDATESTAMP
ON INVCOST AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE INVCOST
		SET INVCOST.UPDATESTAMP = GETDATE()
	FROM INVCOST
		INNER JOIN inserted ON 
			INVCOST.ITEMNUM = inserted.ITEMNUM AND INVCOST.DATEIN = inserted.DATEIN AND
			INVCOST.TIMEIN = inserted.TIMEIN AND INVCOST.WAREHOUSEID = inserted.WAREHOUSEID
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_WOMETER_UPDATESTAMP]'))
DROP TRIGGER BDS_WOMETER_UPDATESTAMP
GO

CREATE TRIGGER BDS_WOMETER_UPDATESTAMP
ON WOMETER AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE WOMETER
		SET WOMETER.UPDATESTAMP = GETDATE()
	FROM WOMETER
		INNER JOIN inserted ON 
			WOMETER.WONUM = inserted.WONUM AND WOMETER.CLOSEDATE = inserted.CLOSEDATE AND WOMETER.SITEID = inserted.SITEID AND
			WOMETER.EQNUM = inserted.EQNUM AND WOMETER.LOCATION = inserted.LOCATION AND WOMETER.SUBLOCATION1 = inserted.SUBLOCATION1 AND
			WOMETER.SUBLOCATION2 = inserted.SUBLOCATION2 AND WOMETER.SUBLOCATION3 = inserted.SUBLOCATION3 AND
			WOMETER.METERNUM = inserted.METERNUM
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_MANUFACT_UPDATESTAMP]'))
DROP TRIGGER BDS_MANUFACT_UPDATESTAMP
GO

CREATE TRIGGER BDS_MANUFACT_UPDATESTAMP
ON MANUFACT AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE MANUFACT
		SET MANUFACT.UPDATESTAMP = GETDATE()
	FROM MANUFACT
		INNER JOIN inserted ON 
			MANUFACT.MANUFACTID = inserted.MANUFACTID
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_WOE_UPDATESTAMP]'))
DROP TRIGGER BDS_WOE_UPDATESTAMP
GO

CREATE TRIGGER BDS_WOE_UPDATESTAMP
ON WOE AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE WOE
		SET WOE.UPDATESTAMP = GETDATE()
	FROM WOE
		INNER JOIN inserted ON 
			WOE.WONUM = inserted.WONUM AND 
			WOE.CLOSEDATE = inserted.CLOSEDATE AND 
			WOE.SITEID = inserted.SITEID AND 
			WOE.EQNUM = inserted.EQNUM AND 
			WOE.LOCATION = inserted.LOCATION AND 
			WOE.SUBLOCATION1 = inserted.SUBLOCATION1 AND
			WOE.SUBLOCATION2 = inserted.SUBLOCATION2 AND 
			WOE.SUBLOCATION3 = inserted.SUBLOCATION3 AND
			WOE.EMPCODE = inserted.EMPCODE AND
			WOE.WODATE = inserted.WODATE
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_MP2USER_UPDATESTAMP]'))
DROP TRIGGER BDS_MP2USER_UPDATESTAMP
GO

CREATE TRIGGER BDS_MP2USER_UPDATESTAMP
ON MP2USER AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE MP2USER
		SET MP2USER.UPDATESTAMP = GETDATE()
	FROM MP2USER
		INNER JOIN inserted ON MP2USER.USERID = inserted.USERID
END
GO
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[BDS_SECURITY_UPDATESTAMP]'))
DROP TRIGGER BDS_SECURITY_UPDATESTAMP
GO

CREATE TRIGGER BDS_SECURITY_UPDATESTAMP
ON SECURITY AFTER INSERT, UPDATE
AS
BEGIN
	UPDATE SECURITY
		SET SECURITY.UPDATESTAMP = GETDATE()
	FROM SECURITY
		INNER JOIN inserted ON
			SECURITY.ROLEID = inserted.ROLEID AND
			SECURITY.FORMID = inserted.FORMID AND
			SECURITY.OBJECTID = inserted.OBJECTID
END
GO
