GO
/****** Object:  StoredProcedure [dbo].[BDSMP2_BUILD_SYNCACTION]    Script Date: 09/12/2012 16:26:30 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER    PROCEDURE [dbo].[BDSMP2_BUILD_SYNCACTION]
(
   @DEVICEID nvarchar(50),
   @USERID nvarchar(50),
   @LASTSYNCDATE datetime,
   @SITEFILTER nvarchar(50),
   @FILTER int
  ) 
AS
DECLARE
@firstsync int

	/* SET NOCOUNT ON */
	-- FILTER = 0 Download by AssignedTo
	-- FILTER = 1 download by craft
	-- FILTER = 2 download all
	/* WO */
	/* BDSMP2_WO_SYNCSTATE */
	/* BDSMP2_WO_SYNCACTION*/ 
	
	/* SYNCACTION = 'NEW' - 
		WO.ASSIGNEDTO = @USERID 
		AND WONUM NOT IN BDSMP2_WO_SYNCSTATE */
	select @firstsync = 0
	IF (@LASTSYNCDATE = '1900-1-1 00:00:00')
	BEGIN
		select @firstsync = 1
	END
	UPDATE WOEQLIST SET WOEQLIST.DEPARTMENT = EQUIP.DEPT, WOEQLIST.COSTCENTER = EQUIP.COSTCENTER
	FROM WOEQLIST
	JOIN EQUIP ON WOEQLIST.EQNUM = EQUIP.EQNUM
	WHERE WOEQLIST.DEPARTMENT IS NULL AND WOEQLIST.COSTCENTER IS NULL
	IF(@FILTER = 2)
	BEGIN
		INSERT INTO BDSMP2_WO_SYNCACTION (USERID, DEVICEID, WONUM, SITEID, SYNCACTION)
			SELECT DISTINCT @USERID, @DEVICEID, WO.WONUM, WO.SITEID, 'NEW' 
			FROM WO, WOEQLIST
			WHERE WO.WONUM NOT IN 
			(
				SELECT DISTINCT BDSMP2_WO_SYNCSTATE.WONUM 
				FROM BDSMP2_WO_SYNCSTATE
				WHERE BDSMP2_WO_SYNCSTATE.USERID = @USERID
				AND BDSMP2_WO_SYNCSTATE.DEVICEID = @DEVICEID
			)
			AND WO.STATUS IN ('H','R','O')
	        	AND WO.SITEID LIKE @SITEFILTER
			AND WOEQLIST.WONUM = WO.WONUM
			--AND WOEQLIST.EQNUM != '-'
			AND WO.CLOSEDATE = '1900-01-01 00:00:00.000'
	
		/* SYNCACTION = 'CHANGED' - 
			WO.ASSIGNEDTO = @USERID  */
		
		INSERT INTO BDSMP2_WO_SYNCACTION (USERID, DEVICEID, WONUM, SITEID, SYNCACTION)
			SELECT DISTINCT @USERID, @DEVICEID, WO.WONUM, WO.SITEID, 'CHANGED' 
				FROM WO JOIN BDSMP2_WO_SYNCSTATE ON WO.WONUM = BDSMP2_WO_SYNCSTATE.WONUM
				/*FROM WO, BDSMP2_WO_SYNCSTATE
				WHERE WO.WONUM = BDSMP2_WO_SYNCSTATE.WONUM
				OR 
				(
					(
						WO.STATUS IN ('C','M') 
						AND BDSMP2_WO_SYNCSTATE.STATUS IN ('H','R','O')
					)
				)*/
				AND WO.UPDATESTAMP > @LASTSYNCDATE
		                AND WO.SITEID LIKE @SITEFILTER
				AND WO.CLOSEDATE = '1900-01-01 00:00:00.000'
				AND WO.WONUM NOT IN
					(SELECT WONUM FROM BDSMP2_WO_SYNCACTION 
						WHERE USERID = @USERID AND DEVICEID = @DEVICEID)
						
		--Handle closed and completed
		IF (@firstsync = 0)	
		BEGIN
			
				Delete BDSMP2_WO_SYNCACTION where USERID = @USERID and DEVICEID = @DEVICEID and WONUM in (
					SELECT DISTINCT WO.WONUM
					FROM WO  
					WHERE WO.UPDATESTAMP > @LASTSYNCDATE
					AND WO.SITEID LIKE @SITEFILTER
					AND WO.STATUS IN ('C','M') )
			
				INSERT INTO BDSMP2_WO_SYNCACTION (USERID, DEVICEID, WONUM, SITEID, SYNCACTION)
					SELECT DISTINCT @USERID, @DEVICEID, WO.WONUM, WO.SITEID, 'CHANGED' 
					FROM WO  
					WHERE WO.UPDATESTAMP > @LASTSYNCDATE
					AND WO.SITEID LIKE @SITEFILTER
					AND WO.STATUS IN ('C','M') 	
					/*AND WO.WONUM NOT IN
						(Select WOnum from BDSMP2_WO_SYNCACTION
							WHERE BDSMP2_WO_SYNCACTION.USERID = @USERID
							AND BDSMP2_WO_SYNCACTION.DEVICEID = @DEVICEID)*/
		END
	
		/* SYNCACTION = 'UPDATED' - 
			WO.ASSIGNEDTO = @USERID  */
		INSERT INTO BDSMP2_WO_SYNCACTION (USERID, DEVICEID, WONUM, SITEID, SYNCACTION)
			SELECT DISTINCT @USERID, @DEVICEID, WO.WONUM, WO.SITEID, 'UPDATED' 
				FROM WO, BDSMP2_WO_SYNCSTATE
				WHERE WO.WONUM = BDSMP2_WO_SYNCSTATE.WONUM
				AND WO.ASSIGNEDTO = BDSMP2_WO_SYNCSTATE.ASSIGNEDTO
				AND WO.STATUS IN ('H','R','O')
				AND WO.UPDATESTAMP > @LASTSYNCDATE
				AND BDSMP2_WO_SYNCSTATE.CLIENT_CHANGED <> '1'
				AND BDSMP2_WO_SYNCSTATE.DEVICEID = @DEVICEID
		                AND WO.SITEID LIKE @SITEFILTER
				AND WO.CLOSEDATE = '1900-01-01 00:00:00.000'
				AND WO.WONUM NOT IN
					(SELECT WONUM FROM BDSMP2_WO_SYNCACTION 
						WHERE USERID = @USERID AND DEVICEID = @DEVICEID)
	END
	ELSE
	BEGIN
		IF(@USERID <> 'NULL')
		BEGIN
			IF(@FILTER = 1)
			BEGIN
			INSERT INTO BDSMP2_WO_SYNCACTION (USERID, DEVICEID, WONUM, SITEID, SYNCACTION)
				SELECT DISTINCT @USERID, @DEVICEID, myTable.WONUM, myTable.SITEID, 'NEW' 
				FROM 
				(select * from WO
					WHERE WO.WONUM NOT IN 
						(
							SELECT DISTINCT BDSMP2_WO_SYNCSTATE.WONUM 
							FROM BDSMP2_WO_SYNCSTATE
							WHERE BDSMP2_WO_SYNCSTATE.USERID = @USERID
							AND BDSMP2_WO_SYNCSTATE.DEVICEID =  @DEVICEID
						)
					AND (WO.ASSIGNEDTO IS NULL OR WO.ASSIGNEDTO = 'W2' or WO.AssignedTO like '%')
					AND WO.STATUS IN ('R','O')
					AND WO.SITEID LIKE @SITEFILTER
					AND WO.CLOSEDATE = '1900-01-01 00:00:00.000'
				) myTable
				INNER JOIN WOCRAFT ON
				(WOCRAFT.WONUM = myTable.WONUM)
				INNER JOIN EMP ON
				(EMP.EMPCODE = @USERID OR EMP.CRAFT = WOCRAFT.CRAFT)
				INNER JOIN WOEQLIST ON
				(WOEQLIST.WONUM = myTable.WONUM)
				--AND WOEQLIST.EQNUM != '-')				
/*SELECT DISTINCT @USERID, @DEVICEID, WO.WONUM, WO.SITEID, 'NEW' 
				FROM WO, WOCRAFT, EMP, WOEQLIST
				WHERE WO.WONUM NOT IN 
				(
					SELECT DISTINCT BDSMP2_WO_SYNCSTATE.WONUM 
					FROM BDSMP2_WO_SYNCSTATE
					WHERE BDSMP2_WO_SYNCSTATE.USERID = @USERID
					AND BDSMP2_WO_SYNCSTATE.DEVICEID = @DEVICEID
				)
				AND WOCRAFT.WONUM = WO.WONUM 
				AND EMP.CRAFT = WOCRAFT.CRAFT 
				or EMP.EMPCODE = @USERID
				AND (WO.ASSIGNEDTO IS NULL OR WO.ASSIGNEDTO = 'W2')
				AND WO.STATUS IN ('R','O')
		        	AND WO.SITEID LIKE @SITEFILTER
				AND WOEQLIST.WONUM = WO.WONUM
				AND WOEQLIST.EQNUM != '-'*/	
				
			END
			ELSE
			BEGIN
			
			INSERT INTO BDSMP2_WO_SYNCACTION (USERID, DEVICEID, WONUM, SITEID, SYNCACTION)
			SELECT DISTINCT @USERID, @DEVICEID, WO.WONUM, WO.SITEID, 'NEW' 
			FROM WO, WOEQLIST
			WHERE WO.WONUM NOT IN 
			(
				SELECT DISTINCT BDSMP2_WO_SYNCSTATE.WONUM 
				FROM BDSMP2_WO_SYNCSTATE
				WHERE BDSMP2_WO_SYNCSTATE.USERID = @USERID
				AND BDSMP2_WO_SYNCSTATE.DEVICEID = @DEVICEID
			)
			AND WO.ASSIGNEDTO = @USERID
			AND WO.STATUS IN ('H','R','O')
	        	AND WO.SITEID LIKE @SITEFILTER
			AND WOEQLIST.WONUM = WO.WONUM
			--AND WOEQLIST.EQNUM != '-'
			AND WO.CLOSEDATE = '1900-01-01 00:00:00.000'
		END

	
		/* SYNCACTION = 'CHANGED' - 
			WO.ASSIGNEDTO = @USERID  */
		
		INSERT INTO BDSMP2_WO_SYNCACTION (USERID, DEVICEID, WONUM, SITEID, SYNCACTION)
			SELECT DISTINCT @USERID, @DEVICEID, WO.WONUM, WO.SITEID, 'CHANGED' 
				FROM WO join BDSMP2_WO_SYNCSTATE on WO.WONUM = BDSMP2_WO_SYNCSTATE.WONUM 
				WHERE BDSMP2_WO_SYNCSTATE.USERID = @USERID and BDSMP2_WO_SYNCSTATE.DEVICEID = @DEVICEID 
				/*AND 
				(
					WO.ASSIGNEDTO = BDSMP2_WO_SYNCSTATE.ASSIGNEDTO
					/*OR 
					(
						WO.STATUS IN ('C','M') 
						AND BDSMP2_WO_SYNCSTATE.STATUS IN ('H','R','O')
					)*/
				)*/
				AND WO.UPDATESTAMP > @LASTSYNCDATE
		        AND WO.SITEID LIKE @SITEFILTER
				AND WO.CLOSEDATE = '1900-01-01 00:00:00.000'
				AND WO.WONUM NOT IN
					(Select WOnum from BDSMP2_WO_SYNCACTION
						WHERE BDSMP2_WO_SYNCACTION.USERID = @USERID
						AND BDSMP2_WO_SYNCACTION.DEVICEID = @DEVICEID
					)
					
		--Add to support Closing open WO from MP2
		/*INSERT INTO BDSMP2_WO_SYNCACTION (USERID, DEVICEID, WONUM, SITEID, SYNCACTION)
			SELECT DISTINCT @USERID, @DEVICEID, WO.WONUM, WO.SITEID, 'CHANGED' 
				FROM WO join BDSMP2_WO_SYNCSTATE on WO.WONUM = BDSMP2_WO_SYNCSTATE.WONUM 
				WHERE BDSMP2_WO_SYNCSTATE.USERID = @USERID and BDSMP2_WO_SYNCSTATE.DEVICEID = @DEVICEID 
				AND WO.UPDATESTAMP > @LASTSYNCDATE
		        AND WO.SITEID LIKE @SITEFILTER
				AND WO.STATUS IN ('C','M') 
				AND BDSMP2_WO_SYNCSTATE.STATUS IN ('H','R','O')
				AND WO.WONUM NOT IN
					(Select WOnum from BDSMP2_WO_SYNCACTION
						WHERE BDSMP2_WO_SYNCACTION.USERID = @USERID
						AND BDSMP2_WO_SYNCACTION.DEVICEID = @DEVICEID)*/
		IF (@firstsync = 0)	
		BEGIN			
			INSERT INTO BDSMP2_WO_SYNCACTION (USERID, DEVICEID, WONUM, SITEID, SYNCACTION)
				SELECT DISTINCT @USERID, @DEVICEID, WO.WONUM, WO.SITEID, 'CHANGED' 
				FROM WO  
				WHERE WO.UPDATESTAMP > @LASTSYNCDATE
			        AND WO.SITEID LIKE @SITEFILTER
					AND WO.STATUS IN ('C','M') 
					AND WO.WONUM NOT IN
						(Select WOnum from BDSMP2_WO_SYNCACTION
							WHERE BDSMP2_WO_SYNCACTION.USERID = @USERID
							AND BDSMP2_WO_SYNCACTION.DEVICEID = @DEVICEID)
		END
	
		/* SYNCACTION = 'UPDATED' - 
			WO.ASSIGNEDTO = @USERID  */
		INSERT INTO BDSMP2_WO_SYNCACTION (USERID, DEVICEID, WONUM, SITEID, SYNCACTION)
			SELECT DISTINCT @USERID, @DEVICEID, WO.WONUM, WO.SITEID, 'UPDATED' 
				FROM WO, BDSMP2_WO_SYNCSTATE
				WHERE WO.WONUM = BDSMP2_WO_SYNCSTATE.WONUM
				AND WO.ASSIGNEDTO = BDSMP2_WO_SYNCSTATE.ASSIGNEDTO
				AND WO.ASSIGNEDTO = @USERID
				AND WO.STATUS IN ('H','R','O')
				AND WO.UPDATESTAMP > @LASTSYNCDATE
				AND BDSMP2_WO_SYNCSTATE.CLIENT_CHANGED <> '1'
				AND BDSMP2_WO_SYNCSTATE.DEVICEID = @DEVICEID
		        AND WO.SITEID LIKE @SITEFILTER
				AND WO.CLOSEDATE = '1900-01-01 00:00:00.000'
				AND WO.WONUM NOT IN
					(SELECT WONUM FROM BDSMP2_WO_SYNCACTION 
						WHERE USERID = @USERID AND DEVICEID = @DEVICEID)
		END
		--ELSE
		BEGIN
		IF (@USERID = 'NULL')
		BEGIN
		
		INSERT INTO BDSMP2_WO_SYNCACTION (USERID, DEVICEID, WONUM, SITEID, SYNCACTION)
			SELECT DISTINCT @USERID, @DEVICEID, WO.WONUM, WO.SITEID, 'NEW' 
			FROM WO, WOEQLIST
			WHERE WO.WONUM NOT IN 
			(
				SELECT DISTINCT BDSMP2_WO_SYNCSTATE.WONUM 
				FROM BDSMP2_WO_SYNCSTATE
				WHERE BDSMP2_WO_SYNCSTATE.USERID IS NULL
				AND BDSMP2_WO_SYNCSTATE.DEVICEID = @DEVICEID
			)
			AND WO.ASSIGNEDTO IS NULL
			AND WO.STATUS IN ('H','R','O')
	        	AND WO.SITEID LIKE @SITEFILTER
			AND WOEQLIST.WONUM = WO.WONUM
			--AND WOEQLIST.EQNUM != '-'
			AND WO.CLOSEDATE = '1900-01-01 00:00:00.000'
	
		/* SYNCACTION = 'CHANGED' - 
			WO.ASSIGNEDTO = @USERID  */
		
		INSERT INTO BDSMP2_WO_SYNCACTION (USERID, DEVICEID, WONUM, SITEID, SYNCACTION)
			SELECT DISTINCT @USERID, @DEVICEID, WO.WONUM, WO.SITEID, 'CHANGED' 
				FROM WO JOIN BDSMP2_WO_SYNCSTATE ON WO.WONUM = BDSMP2_WO_SYNCSTATE.WONUM 
				WHERE 
				/*(
					WO.ASSIGNEDTO <> BDSMP2_WO_SYNCSTATE.ASSIGNEDTO
					OR 
					(
						WO.STATUS IN ('C','M') 
						AND BDSMP2_WO_SYNCSTATE.STATUS IN ('H','R','O')
					)
				)
				AND*/ WO.UPDATESTAMP > @LASTSYNCDATE
		                AND WO.SITEID LIKE @SITEFILTER
				AND WO.CLOSEDATE = '1900-01-01 00:00:00.000'
				AND WO.WONUM NOT IN
					(Select WOnum from BDSMP2_WO_SYNCACTION
						WHERE BDSMP2_WO_SYNCACTION.USERID = @USERID
						AND BDSMP2_WO_SYNCACTION.DEVICEID = @DEVICEID
					)
	
		/* SYNCACTION = 'UPDATED' - 
			WO.ASSIGNEDTO = @USERID  */
		INSERT INTO BDSMP2_WO_SYNCACTION (USERID, DEVICEID, WONUM, SITEID, SYNCACTION)
			SELECT DISTINCT @USERID, @DEVICEID, WO.WONUM, WO.SITEID, 'UPDATED' 
				FROM WO, BDSMP2_WO_SYNCSTATE
				WHERE WO.WONUM = BDSMP2_WO_SYNCSTATE.WONUM
				AND WO.ASSIGNEDTO = BDSMP2_WO_SYNCSTATE.ASSIGNEDTO
				AND WO.ASSIGNEDTO IS NULL
				AND WO.STATUS IN ('H','R','O')
				AND WO.UPDATESTAMP > @LASTSYNCDATE
				AND BDSMP2_WO_SYNCSTATE.CLIENT_CHANGED <> '1'
				AND BDSMP2_WO_SYNCSTATE.DEVICEID = @DEVICEID
		                AND WO.SITEID LIKE @SITEFILTER
				AND WO.CLOSEDATE = '1900-01-01 00:00:00.000'
				AND WO.WONUM NOT IN
					(Select WOnum from BDSMP2_WO_SYNCACTION
						WHERE BDSMP2_WO_SYNCACTION.USERID = @USERID
						AND BDSMP2_WO_SYNCACTION.DEVICEID = @DEVICEID
					)
		END
		END
	END
	RETURN


